/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
	debug( "load()" );
	
    dashcode.setupParts();
	UIinit();
	initAccounts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
	debug( "remove()" );
	
	deletePreferences();
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
	debug( "hide()" );
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
	debug( "show()" );
	
	if ( !g_checkInterval ) {
		collectiveCheckMail();
	}
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
	
	debug( "sync()" );
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
	debug( "showBack( " + event + " )" );

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
		widget.setCloseBoxOffset( 12, 13 );
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	
	// Aktuelles Anzeige-Element in StackLayout abfragen
	var stackLayout = document.getElementById('settingsStackLayout').object; // Ersetzen durch ID des StackLayouts
	var currentView = stackLayout.getCurrentView();
	
	if ( currentView.id == "audioPlayerSettings" ) {
		g_pasteTarget = 2;
	} else {
		g_pasteTarget = 0;
	}
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
	debug( "showFront( " + event + ")" );

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
		widget.setCloseBoxOffset( 24, 33 );
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	
	g_pasteTarget = 1;
	UIdisplayName();
	deletePreferences();
	savePreferences();
	collectiveCheckMail();
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function debug( string )
{
	_debug( "main : " + string );
}

ginit_MailAccountsGetter = null;
var g_MailAccounts = new Array();

function initAccounts()
{
	debug( "initAccounts()" );
	
	ginit_MailAccountsGetter = new mkiiMailAccounts( g_MailAccounts );
	ginit_MailAccountsGetter.acquireMailAccounts( initAccounts2 );
}

function initAccounts2()
{
	debug( "initAccounts2()" );
	
	delete ginit_MailAccountsGetter;
	
	for ( var acc in g_MailAccounts ) {
		UIaddToAccountList( g_MailAccounts[acc].AccountName );
	}
	
	loadPreferences();
}

var g_newMailCount = 0;

function collectCount(event)
{
	debug( "collectCount( " + event + " )" );
	
	g_newMailCount += event;
}

function collectFail()
{
	debug( "collectFail()!!!" );
}

var g_growlFromPrev = "";
var g_growlSubjectPrev = "";
var g_DateLast = new Date( 0 );

function collectDone( event )
{
	debug( "collectDone()" );
	
	g_checkMailCounter--;
	
	if ( !g_checkMailCounter ) {
		UIactivityIndicator( false );
		UIbadgeCount( g_newMailCount );
		
		var from = "";
		var subject = "";
		var date = new Date( 0 );
		
		debug( "date : " + date );
		debug( "g_collectedMailHeaders : " + g_collectedMailHeaders );
		
		for ( var mail in g_collectedMailHeaders ) {
			debug( g_collectedMailHeaders[mail]["date"] );
			
			if ( (g_collectedMailHeaders[mail]["from"] != "") || (g_collectedMailHeaders[mail]["subject"] != "") ) {
				if ( g_collectedMailHeaders[mail]["date"] > date ) {
					from = g_collectedMailHeaders[mail]["from"];
					subject = g_collectedMailHeaders[mail]["subject"];
					date = g_collectedMailHeaders[mail]["date"];
				}
			}
		}
		
		from = widget.system( "/usr/bin/perl MailHeaderDecoding.pl \"" + from + "\"", null ).outputString;
		subject = widget.system( "/usr/bin/perl MailHeaderDecoding.pl \"" + subject + "\"", null ).outputString;
		
		UIsetMailHeader( from, subject );
		
		if ( date > g_DateLast ) {
			g_DateLast = date;
			UIgrowlAnnouncement( from, subject );
			UIplayAudio();
		}
		
		/*
		if ( (from != "") || (subject != "") ) {
			if ( (g_growlFromPrev != from) || (g_growlSubjectPrev != subject) ) {
				UIgrowlAnnouncement( from, subject );
				g_growlFromPrev = from;
				g_growlSubjectPrev = subject;
			}
		}
		*/
	}
}

var g_collectedMailHeaders = new Array();

function collectHeaders( FROM, SUBJECT, DATE ) {
	debug( "collectHeaders( " + FROM + ", " + SUBJECT + ", " + DATE + " )" );

	var temp = new Object();
	temp["from"] = FROM;
	temp["subject"] = SUBJECT;
	temp["date"] = new Date( DATE );
	
	//quirk fix for Tiger which cannot parse "Mon, 16 Mar 2009 07:11:39 +0100 (CET)"
	if ( temp["date"].toString() == "Invalid Date" ) {
		debug( "cannot parse Date" );
		DATE = DATE.substring( 0, DATE.lastIndexOf( " " ) );
		temp["date"] = new Date( DATE );
		
		if ( temp["date"].toString() == "Invalid Date" ) {
			debug( "fatal error. cannot parse Date" );
			temp["date"] = new Date( 1 );
		}
	}
	
	debug( "temp[\"date\"] : " + temp["date"] ); 
	
	g_collectedMailHeaders.push( temp );
}

g_checkMailCounter = 0;

function collectiveCheckMail()
{
	debug( "collectiveCheckMail()" );

	UIactivityIndicator( true );
	g_newMailCount = 0;
	g_checkMailCounter = 0;
	delete g_collectedMailHeaders;
	g_collectedMailHeaders = new Array();
	
	for ( var acc in g_MailAccounts ) {
        if ( g_MailAccounts[acc].handler ) {
			g_checkMailCounter++;
			debug( "testing " + g_MailAccounts[acc].AccountName );
			g_MailAccounts[acc].handler.checkMail();
		}
	}
	
	if ( !g_checkMailCounter ) {
		UIactivityIndicator( false );
	}
}

function loadPreferences()
{
	debug( "loadPreferences()" );
	
	for ( var acc in g_MailAccounts ) {
		var preferenceForKey = g_MailAccounts[acc].uniqueId;
		preferenceForKey = widget.preferenceForKey(widget.identifier + "-" + preferenceForKey);
		
		if ( preferenceForKey ) {
			g_MailAccounts[acc].Password = base64Decode( preferenceForKey );
			applyLoadedAccount(acc);
		}
	}
	
	var preferenceForKey = "checkInterval";
	preferenceForKey = widget.preferenceForKey(widget.identifier + "-" + preferenceForKey);
	
	if ( preferenceForKey != undefined ) {
		UIsetCheckInterval( preferenceForKey );
	} else {
		UIsetCheckInterval( 15 );
	}
	
	var preferenceForKey = "audioVolume";
	preferenceForKey = widget.preferenceForKey(widget.identifier + "-" + preferenceForKey);
	
	if ( preferenceForKey != undefined ) {
		UIsetVolume( preferenceForKey );
	} else {
		UIsetVolume( 256 );
	}
	
	var tempCustomAudio = new Array();
	
	for ( var snd = 0; snd < 32; snd++ ) {
		var preferenceForKey = "customAudio" + snd;
		preferenceForKey = widget.preferenceForKey(widget.identifier + "-" + preferenceForKey);
		
		if ( preferenceForKey ) {
			tempCustomAudio.push( preferenceForKey );
		}
	}
	
	if ( tempCustomAudio.length > 0 ) {
		g_customAudio = tempCustomAudio;
		UIaudioDragLeave();
	}
	
	var preferenceForKey = "autoUpdate";
	preferenceForKey = widget.preferenceForKey(widget.identifier + "-" + preferenceForKey);
	
	if ( preferenceForKey != undefined ) {
		UIsetUpdate( preferenceForKey );
	} else {
		UIsetUpdate( true );
	}
	
	var preferenceForKey = "name";
	preferenceForKey = widget.preferenceForKey(widget.identifier + "-" + preferenceForKey);
	
	if ( preferenceForKey != undefined ) {
		UIsetName( preferenceForKey );
	}
	
	if ( g_autoUpdate ) {
		g_autoUpdateManager = new mkiiAutoUpdate( "http://support.kwasi-ich.de/MailWidgetUpdate.xml", UIaskForUpdate );
		g_autoUpdateManager.checkForUpdate();
	}
	
	UIdisplayName();
	g_wakeAfterSleep = new mkiiSleep( wakeUp, 300000, 15000 );
	collectiveCheckMail();
}

function applyLoadedAccount(event)
{
	debug( "applyLoadedAccount( " + event + " )" );
	
	if ( g_MailAccounts[event].AccountType == "POPAccount" ) {
		//handle POP3
		g_MailAccounts[event].handler = new mkiiPopClient( g_MailAccounts[event], collectCount, collectHeaders, collectFail, collectDone );
	} else {
		//handle IMAP
		g_MailAccounts[event].handler = new mkiiImapClient( g_MailAccounts[event], collectCount, collectHeaders, collectFail, collectDone );
	}
	
	UIsetIndicator(event, 1);
}


function savePreferences()
{
	debug( "savePreferences()" );
	
	for ( var acc in g_MailAccounts ) {
        if ( g_MailAccounts[acc].handler ) {
			widget.setPreferenceForKey( base64Encode(g_MailAccounts[acc].Password), widget.identifier + "-" + g_MailAccounts[acc].uniqueId );
		} else {
			widget.setPreferenceForKey( null, widget.identifier + "-" + g_MailAccounts[acc].uniqueId );
		}
	}
	
	widget.setPreferenceForKey( g_checkInterval, widget.identifier + "-" + "checkInterval" );
	widget.setPreferenceForKey( g_audioVolume, widget.identifier + "-" + "audioVolume" );	
	
	for ( var snd in g_customAudio ) {
		widget.setPreferenceForKey( g_customAudio[snd], widget.identifier + "-" + "customAudio" + snd );
	}
	
	widget.setPreferenceForKey( g_autoUpdate, widget.identifier + "-" + "autoUpdate" );
	widget.setPreferenceForKey( g_name, widget.identifier + "-" + "name" );
}


function deletePreferences()
{
	debug( "deletePreferences()" );
	
	for ( var acc in g_MailAccounts ) {
		widget.setPreferenceForKey( null, widget.identifier + "-" + g_MailAccounts[acc].uniqueId );
	}
	
	widget.setPreferenceForKey( null, widget.identifier + "-" + "checkInterval" );
	widget.setPreferenceForKey( null, widget.identifier + "-" + "audioVolume" );	
	
	for ( var snd = 0; snd < 32; snd++ ) {
		widget.setPreferenceForKey( null, widget.identifier + "-" + "customAudio" + snd );
	}

	widget.setPreferenceForKey( null, widget.identifier + "-" + "autoUpdate" );
	widget.setPreferenceForKey( null, widget.identifier + "-" + "name" );
}

var g_checkIntervalManager = null; //setInterval( collectiveCheckMail, 10 * 60 * 1000 );

var g_wakeAfterSleep = null;

function resetInterval()
{
	debug( "resetInterval()" );

	debug( g_checkInterval );
	clearInterval( g_checkIntervalManager );
	
	if ( g_checkInterval ) {
		g_checkIntervalManager = setInterval( collectiveCheckMail, g_checkInterval * 60 * 1000 );
	} else {
		g_checkIntervalManager = null;
	}
}

function wakeUp()
{
	debug( "wakeUp()" );
	
	resetInterval();
	collectiveCheckMail();
}

var g_autoUpdateManager = null;

var _debugBuffer = "";

function _debug( STRING ) {
	return;
	STRING = STRING.replace( /\r/g, '' );
	var now = new Date();
	var x = 0;
	
	switch ( x ) {
		case 0:
			alert( STRING );
			break;
		case 1:
			var stringLines = STRING.split( "\n" );
			
			for ( var line in stringLines ) {
				alert( stringLines[line] );
			}
			
			break;
		case 2:
			_debugBuffer += now;
			_debugBuffer += '\n';
			_debugBuffer += STRING;
			_debugBuffer += '\n';
			
			if ( _debugBuffer.length > 4096 ) {
				widget.system( "echo \"" + _debugBuffer + "\" >> ~/Desktop/Widget.log", function() {} );
				//alert( _debugBuffer );
				_debugBuffer = "";
			}
		default:
	}
}
